##// END OF EJS Templates
Align vidal repo on drtyhlpr
vidal -
r728:cb531218d6a8
parent child
Show More
@@ -1,48 +1,48
1 1 #
2 2 # Debootstrap basic system
3 3 #
4 4
5 5 # Load utility functions
6 6 . ./functions.sh
7 7
8 8 VARIANT=""
9 9 COMPONENTS="main"
10 10
11 11 # Use non-free Debian packages if needed
12 12 if [ "$ENABLE_NONFREE" = true ] ; then
13 13 COMPONENTS="main,non-free,contrib"
14 14 fi
15 15
16 16 # Use minbase bootstrap variant which only includes essential packages
17 17 if [ "$ENABLE_MINBASE" = true ] ; then
18 18 VARIANT="--variant=minbase"
19 19 fi
20 20
21 21
22 22 # Exclude packages if required by Debian release
23 if [ "$RELEASE" = "stretch" ] || [ "$RELEASE" = "buster" ] ; then
24 EXCLUDES="--exclude=init,systemd-sysv"
25 fi
23 #if [ "$RELEASE" = "stretch" ] || [ "$RELEASE" = "buster" ] ; then
24 # APT_EXCLUDES="--exclude=init,systemd-sysv"
25 #fi
26 26
27 27
28 28 # Base debootstrap (unpack only)
29 29 http_proxy=${APT_PROXY} debootstrap ${APT_EXCLUDES} --arch="${RELEASE_ARCH}" --foreign ${VARIANT} --components="${COMPONENTS}" --include="${APT_INCLUDES}" "${RELEASE}" "${R}" "http://${APT_SERVER}/debian"
30 30
31 31 # Copy qemu emulator binary to chroot
32 32 install -m 755 -o root -g root "${QEMU_BINARY}" "${R}${QEMU_BINARY}"
33 33
34 34 # Copy debian-archive-keyring.pgp
35 35 mkdir -p "${R}/usr/share/keyrings"
36 36 install_readonly /usr/share/keyrings/debian-archive-keyring.gpg "${R}/usr/share/keyrings/debian-archive-keyring.gpg"
37 37
38 38 # Complete the bootstrapping process
39 39 chroot_exec /debootstrap/debootstrap --second-stage
40 40
41 41 # Mount required filesystems
42 42 mount -t proc none "${R}/proc"
43 43 mount -t sysfs none "${R}/sys"
44 44
45 45 # Mount pseudo terminal slave if supported by Debian release
46 46 if [ -d "${R}/dev/pts" ] ; then
47 47 mount --bind /dev/pts "${R}/dev/pts"
48 48 fi
@@ -1,69 +1,69
1 1 #
2 2 # Setup APT repositories
3 3 #
4 4
5 5 # Load utility functions
6 6 . ./functions.sh
7 7
8 8 # Install and setup APT proxy configuration
9 9 if [ -z "$APT_PROXY" ] ; then
10 10 install_readonly files/apt/10proxy "${ETC_DIR}/apt/apt.conf.d/10proxy"
11 11 sed -i "s/\"\"/\"${APT_PROXY}\"/" "${ETC_DIR}/apt/apt.conf.d/10proxy"
12 12 fi
13 13
14 14 if [ "$BUILD_KERNEL" = false ] ; then
15 15 # Install APT pinning configuration for flash-kernel package
16 16 install_readonly files/apt/flash-kernel "${ETC_DIR}/apt/preferences.d/flash-kernel"
17 17
18 18 # Install APT sources.list
19 19 install_readonly files/apt/sources.list "${ETC_DIR}/apt/sources.list"
20 20 echo "deb ${COLLABORA_URL} ${RELEASE} rpi2" >> "${ETC_DIR}/apt/sources.list"
21 21
22 22 # Upgrade collabora package index and install collabora keyring
23 23 chroot_exec apt-get -qq -y update
24 24 # Removed --allow-unauthenticated as suggested after modification on _apt privileges
25 25 chroot_exec apt-get -qq -y install collabora-obs-archive-keyring
26 26 else # BUILD_KERNEL=true
27 27 # Install APT sources.list
28 28 install_readonly files/apt/sources.list "${ETC_DIR}/apt/sources.list"
29 29
30 30 # Use specified APT server and release
31 31 sed -i "s/\/ftp.debian.org\//\/${APT_SERVER}\//" "${ETC_DIR}/apt/sources.list"
32 32 sed -i "s/ jessie/ ${RELEASE}/" "${ETC_DIR}/apt/sources.list"
33 33 fi
34 34
35 35
36 36 # Use specified APT server and release
37 37 sed -i "s/\/ftp.debian.org\//\/${APT_SERVER}\//" "${ETC_DIR}/apt/sources.list"
38 38
39 #Fix for changing path for security updates in testing/bullseye
39 #Fix for changing path for security updates in testing
40 40 if [ "$RELEASE" = "testing" ] ; then
41 41 sed -i "s,buster\\/updates,testing-security," "${ETC_DIR}/apt/sources.list"
42 42 sed -i "s/ buster/ ${RELEASE}/" "${ETC_DIR}/apt/sources.list"
43 43 fi
44 44
45 45 if [ -z "$RELEASE" ] ; then
46 46 # Change release in sources list
47 47 sed -i "s/ buster/ ${RELEASE}/" "${ETC_DIR}/apt/sources.list"
48 48 fi
49 49
50 50 # Upgrade package index and update all installed packages and changed dependencies
51 51 chroot_exec apt-get -qq -y update
52 52 chroot_exec apt-get -qq -y -u dist-upgrade
53 53
54 54 # Install additional packages
55 55 if [ "$APT_INCLUDES_LATE" ] ; then
56 56 chroot_exec apt-get -qq -y install $(echo "$APT_INCLUDES_LATE" |tr , ' ')
57 57 fi
58 58
59 59 # Install Debian custom packages
60 60 if [ -d packages ] ; then
61 61 for package in packages/*.deb ; do
62 62 cp "$package" "${R}"/tmp
63 63 chroot_exec dpkg --unpack /tmp/"$(basename "$package")"
64 64 done
65 65 fi
66 66
67 67 chroot_exec apt-get -qq -y -f install
68 68
69 69 chroot_exec apt-get -qq -y check
@@ -1,53 +1,47
1 1 #
2 2 # Build and Setup fbturbo Xorg driver
3 3 #
4 4
5 5 # Load utility functions
6 6 . ./functions.sh
7 7
8 8 if [ "$ENABLE_FBTURBO" = true ] ; then
9 9 # Install c/c++ build environment inside the chroot
10 10 chroot_install_cc
11 11
12 12 # Copy existing fbturbo sources into chroot directory
13 13 if [ -n "$FBTURBOSRC_DIR" ] && [ -d "$FBTURBOSRC_DIR" ] ; then
14 14 # Copy local fbturbo sources
15 15 cp -r "${FBTURBOSRC_DIR}" "${R}/tmp"
16 16 else
17 17 # Create temporary directory for fbturbo sources
18 18 temp_dir=$(as_nobody mktemp -d)
19 19
20 20 # Fetch fbturbo sources
21 21 as_nobody git -C "${temp_dir}" clone "${FBTURBO_URL}"
22 22
23 23 # Move downloaded fbturbo sources
24 24 mv "${temp_dir}/xf86-video-fbturbo" "${R}/tmp/"
25 25
26 26 # Remove temporary directory for fbturbo sources
27 27 rm -fr "${temp_dir}"
28 28 fi
29 29
30 30 # Install Xorg build dependencies
31
32 if [ "$RELEASE" = "jessie" ] || [ "$RELEASE" = "stretch" ] || [ "$RELEASE" = "buster" ] ; then
33 chroot_exec apt-get -q -y --no-install-recommends install xorg-dev xutils-dev x11proto-dri2-dev libltdl-dev libtool automake libdrm-dev
34 elif [ "$RELEASE" = "stretch" ] || [ "$RELEASE" = "buster" ] ; then
35 chroot_exec apt-get -q -y --no-install-recommends --allow-unauthenticated install xorg-dev xutils-dev x11proto-dri2-dev libltdl-dev libtool automake libdrm-dev
36 fi
37
31 chroot_exec apt-get -q -y --no-install-recommends --allow-unauthenticated install xorg-dev xutils-dev x11proto-dri2-dev libltdl-dev libtool automake libdrm-dev
38 32
39 33 # Build and install fbturbo driver inside chroot
40 34 chroot_exec /bin/bash -x <<'EOF'
41 35 cd /tmp/xf86-video-fbturbo
42 36 autoreconf -vi
43 37 ./configure --prefix=/usr
44 38 make
45 39 make install
46 40 EOF
47 41
48 42 # Install fbturbo driver Xorg configuration
49 43 install_readonly files/xorg/99-fbturbo.conf "${R}/usr/share/X11/xorg.conf.d/99-fbturbo.conf"
50 44
51 45 # Remove Xorg build dependencies
52 46 chroot_exec apt-get -qq -y --auto-remove purge xorg-dev xutils-dev x11proto-dri2-dev libltdl-dev libtool automake libdrm-dev
53 47 fi
@@ -1,122 +1,122
1 1 # This file contains utility functions used by rpi23-gen-image.sh
2 2
3 3 cleanup (){
4 4 set +x
5 5 set +e
6 6
7 7 # Remove exports from nexmon
8 8 unset KERNEL
9 9 unset ARCH
10 10 unset SUBARCH
11 11 unset CCPLUGIN
12 12 unset ZLIBFLATE
13 13 unset Q
14 14 unset NEXMON_SETUP_ENV
15 15 unset HOSTUNAME
16 16 unset PLATFORMUNAME
17 17
18 18 # Identify and kill all processes still using files
19 19 echo "killing processes using mount point ..."
20 20 fuser -k "${R}"
21 21 sleep 3
22 22 fuser -9 -k -v "${R}"
23 23
24 24 # Clean up temporary .password file
25 25 if [ -r ".password" ] ; then
26 26 shred -zu .password
27 27 fi
28 28
29 29 # Clean up all temporary mount points
30 30 echo "removing temporary mount points ..."
31 31 umount -l "${R}/proc" 2> /dev/null
32 32 umount -l "${R}/sys" 2> /dev/null
33 33 umount -l "${R}/dev/pts" 2> /dev/null
34 34 umount "$BUILDDIR/mount/boot/firmware" 2> /dev/null
35 35 umount "$BUILDDIR/mount" 2> /dev/null
36 36 cryptsetup close "${CRYPTFS_MAPPING}" 2> /dev/null
37 37 losetup -d "$ROOT_LOOP" 2> /dev/null
38 38 losetup -d "$FRMW_LOOP" 2> /dev/null
39 39 trap - 0 1 2 3 6
40 40 }
41 41
42 42 chroot_exec() {
43 43 # Exec command in chroot
44 44 LANG=C LC_ALL=C DEBIAN_FRONTEND=noninteractive chroot "${R}" "$@"
45 45 }
46 46
47 47 as_nobody() {
48 48 # Exec command as user nobody
49 49 sudo -E -u nobody LANG=C LC_ALL=C "$@"
50 50 }
51 51
52 52 install_readonly() {
53 53 # Install file with user read-only permissions
54 54 install -o root -g root -m 644 "$@"
55 55 }
56 56
57 57 install_exec() {
58 58 # Install file with root exec permissions
59 59 install -o root -g root -m 744 "$@"
60 60 }
61 61
62 62 use_template () {
63 63 # Test if configuration template file exists
64 64 if [ ! -r "./templates/${CONFIG_TEMPLATE}" ] ; then
65 65 echo "error: configuration template ${CONFIG_TEMPLATE} not found"
66 66 exit 1
67 67 fi
68 68
69 69 # Load template configuration parameters
70 70 . "./templates/${CONFIG_TEMPLATE}"
71 71 }
72 72
73 73 chroot_install_cc() {
74 74 # Install c/c++ build environment inside the chroot
75 75 if [ -z "${COMPILER_PACKAGES}" ] ; then
76 76 COMPILER_PACKAGES=$(chroot_exec apt-get -s install g++ make bc | grep "^Inst " | awk -v ORS=" " '{ print $2 }')
77 77
78 78
79 if [ "$RELEASE" = "jessie" ] || [ "$RELEASE" = "stretch" ] || [ "$RELEASE" = "buster" ] ; then
79 if [ "$RELEASE" = "stretch" ] || [ "$RELEASE" = "buster" ] || [ "$RELEASE" = "bullseye" ] ; then
80 80 chroot_exec apt-get -q -y --no-install-recommends install ${COMPILER_PACKAGES}
81 elif [ "$RELEASE" = "stretch" ] || [ "$RELEASE" = "buster" ] ; then
81 elif [ "$RELEASE" = "buster" ] || [ "$RELEASE" = "bullseye" ] ; then
82 82 chroot_exec apt-get -q -y --allow-unauthenticated --no-install-recommends install ${COMPILER_PACKAGES}
83 83 fi
84 84
85 85 fi
86 86 }
87 87
88 88 chroot_remove_cc() {
89 89 # Remove c/c++ build environment from the chroot
90 90 if [ -n "${COMPILER_PACKAGES}" ] ; then
91 91 chroot_exec apt-get -qq -y --auto-remove purge ${COMPILER_PACKAGES}
92 92 COMPILER_PACKAGES=""
93 93 fi
94 94 }
95 95
96 96 # https://serverfault.com/a/682849 - converts e.g. /24 to 255.255.255.0
97 97 cdr2mask ()
98 98 {
99 99 # Number of args to shift, 255..255, first non-255 byte, zeroes
100 100 set -- $(( 5 - ($1 / 8) )) 255 255 255 255 $(( (255 << (8 - ($1 % 8))) & 255 )) 0 0 0
101 101 [ $1 -gt 1 ] && shift $1 || shift
102 102 echo ${1-0}.${2-0}.${3-0}.${4-0}
103 103 }
104 104
105 105 # GPL v2.0 - #https://github.com/sakaki-/bcmrpi3-kernel-bis/blob/master/conform_config.sh
106 106 set_kernel_config() {
107 107 # flag as $1, value to set as $2, config must exist at "./.config"
108 108 TGT="CONFIG_${1#CONFIG_}"
109 109 REP="${2}"
110 110 if grep -q "^${TGT}[^_]" .config; then
111 111 sed -i "s/^\(${TGT}=.*\|# ${TGT} is not set\)/${TGT}=${REP}/" .config
112 112 else
113 113 echo "${TGT}"="${2}" >> .config
114 114 fi
115 115 }
116 116
117 117 # unset kernel config parameter
118 118 unset_kernel_config() {
119 119 # unsets flag with the value of $1, config must exist at "./.config"
120 120 TGT="CONFIG_${1#CONFIG_}"
121 121 sed -i "s/^${TGT}=.*/# ${TGT} is not set/" .config
122 } No newline at end of file
122 }
@@ -1,897 +1,897
1 1 #!/bin/sh
2 2 ########################################################################
3 3 # rpi23-gen-image.sh 2015-2017
4 4 #
5 # Advanced Debian "stretch" and "buster" bootstrap script for Raspberry Pi
5 # Advanced Debian "buster" and "bullseye" bootstrap script for Raspberry Pi
6 6 #
7 7 # This program is free software; you can redistribute it and/or
8 8 # modify it under the terms of the GNU General Public License
9 9 # as published by the Free Software Foundation; either version 2
10 10 # of the License, or (at your option) any later version.
11 11 #
12 12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
13 13 #
14 14 # Big thanks for patches and enhancements by 20+ github contributors!
15 15 ########################################################################
16 16
17 17 # Are we running as root?
18 18 if [ "$(id -u)" -ne "0" ] ; then
19 19 echo "error: this script must be executed with root privileges!"
20 20 exit 1
21 21 fi
22 22
23 23 # Check if ./functions.sh script exists
24 24 if [ ! -r "./functions.sh" ] ; then
25 25 echo "error: './functions.sh' required script not found!"
26 26 exit 1
27 27 fi
28 28
29 29 # Load utility functions
30 30 . ./functions.sh
31 31
32 32 # Load parameters from configuration template file
33 33 if [ -n "$CONFIG_TEMPLATE" ] ; then
34 34 use_template
35 35 fi
36 36
37 37 # Introduce settings
38 38 set -e
39 echo -n -e "\n#\n# RPi 0/1/2/3 Bootstrap Settings\n#\n"
39 echo -n -e "\n#\n# RPi 0/1/2/3/4 Bootstrap Settings\n#\n"
40 40 set -x
41 41
42 42 # Raspberry Pi model configuration
43 RPI_MODEL=${RPI_MODEL:=2}
43 RPI_MODEL=${RPI_MODEL:=3}
44 44
45 45 # Debian release
46 46 RELEASE=${RELEASE:=buster}
47 47 if [ $RELEASE = "bullseye" ] ; then
48 48 RELEASE=testing
49 49 fi
50 50
51 51 # Kernel Branch
52 52 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
53 53
54 54 # URLs
55 55 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
56 56 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
57 57 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
58 58 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
59 59 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
60 60 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
61 61 BLUETOOTH_URL=${BLUETOOTH_URL:=https://github.com/RPi-Distro/pi-bluetooth.git}
62 62 NEXMON_URL=${NEXMON_URL:=https://github.com/seemoo-lab/nexmon.git}
63 63 SYSTEMDSWAP_URL=${SYSTEMDSWAP_URL:=https://github.com/Nefelim4ag/systemd-swap.git}
64 64
65 65 # Kernel deb packages for 32bit kernel
66 66 RPI_32_KERNEL_URL=${RPI_32_KERNEL_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel_20180422-141901_armhf.deb}
67 67 RPI_32_KERNELHEADER_URL=${RPI_32_KERNELHEADER_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel-headers_20180422-141901_armhf.deb}
68 68 # Kernel has KVM and zswap enabled - use if KERNEL_* parameters and precompiled kernel are used
69 69 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.19.80.20191022/bcmrpi3-kernel-bis-4.19.80.20191022.tar.xz}
70 70 # Default precompiled 64bit kernel
71 71 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.19.80.20191022/bcmrpi3-kernel-4.19.80.20191022.tar.xz}
72 72 # Sakaki BIS Kernel RPI4 - https://github.com/sakaki-/bcm2711-kernel-bis
73 73 RPI4_64_BIS_KERNEL_URL=${RPI4_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcm2711-kernel-bis/releases/download/4.19.59.20190724/bcm2711-kernel-bis-4.19.59.20190724.tar.xz}
74 74 # Default precompiled 64bit kernel - https://github.com/sakaki-/bcm2711-kernel
75 75 RPI4_64_DEF_KERNEL_URL=${RPI4_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcm2711-kernel-bis/releases/download/4.19.59.20190724/bcm2711-kernel-bis-4.19.59.20190724.tar.xz}
76 76 # Generic
77 77 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_DEF_KERNEL_URL}
78 78 RPI4_64_KERNEL_URL=${RPI4_64_KERNEL_URL:=$RPI4_64_DEF_KERNEL_URL}
79 79 # Kali kernel src - used if ENABLE_NEXMON=true (they patch the wlan kernel modul)
80 80 KALI_KERNEL_URL=${KALI_KERNEL_URL:=https://github.com/Re4son/re4son-raspberrypi-linux.git}
81 81
82 82 # Build directories
83 83 WORKDIR=$(pwd)
84 84 BASEDIR=${BASEDIR:=${WORKDIR}/images/${RELEASE}}
85 85 BUILDDIR="${BASEDIR}/build"
86 86
87 87 # Chroot directories
88 88 R="${BUILDDIR}/chroot"
89 89 ETC_DIR="${R}/etc"
90 90 LIB_DIR="${R}/lib"
91 91 BOOT_DIR="${R}/boot/firmware"
92 92 KERNEL_DIR="${R}/usr/src/linux"
93 93 WLAN_FIRMWARE_DIR="${LIB_DIR}/firmware/brcm"
94 94 BLUETOOTH_FIRMWARE_DIR="${ETC_DIR}/firmware/bt"
95 95
96 96 # Firmware directory: Blank if download from github
97 97 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
98 98
99 99 # General settings
100 100 SET_ARCH=${SET_ARCH:=32}
101 101 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
102 102 PASSWORD=${PASSWORD:=raspberry}
103 103 USER_PASSWORD=${USER_PASSWORD:=raspberry}
104 104 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
105 105 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
106 106 EXPANDROOT=${EXPANDROOT:=true}
107 107 ENABLE_DPHYSSWAP=${ENABLE_DPHYSSWAP:=true}
108 108
109 109 # Keyboard settings
110 110 XKB_MODEL=${XKB_MODEL:=""}
111 111 XKB_LAYOUT=${XKB_LAYOUT:=""}
112 112 XKB_VARIANT=${XKB_VARIANT:=""}
113 113 XKB_OPTIONS=${XKB_OPTIONS:=""}
114 114
115 115 # Network settings (DHCP)
116 116 ENABLE_DHCP=${ENABLE_DHCP:=true}
117 117
118 118 # Network settings (static)
119 119 NET_ADDRESS=${NET_ADDRESS:=""}
120 120 NET_GATEWAY=${NET_GATEWAY:=""}
121 121 NET_DNS_1=${NET_DNS_1:=""}
122 122 NET_DNS_2=${NET_DNS_2:=""}
123 123 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
124 124 NET_NTP_1=${NET_NTP_1:=""}
125 125 NET_NTP_2=${NET_NTP_2:=""}
126 126
127 127 # APT settings
128 128 APT_PROXY=${APT_PROXY:=""}
129 129 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
130 130 KEEP_APT_PROXY=${KEEP_APT_PROXY:=false}
131 131
132 132 # Feature settings
133 133 ENABLE_PRINTK=${ENABLE_PRINTK:=false}
134 134 ENABLE_BLUETOOTH=${ENABLE_BLUETOOTH:=false}
135 135 ENABLE_MINIUART_OVERLAY=${ENABLE_MINIUART_OVERLAY:=false}
136 136 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
137 137 ENABLE_I2C=${ENABLE_I2C:=false}
138 138 ENABLE_SPI=${ENABLE_SPI:=false}
139 139 ENABLE_IPV6=${ENABLE_IPV6:=true}
140 140 ENABLE_SSHD=${ENABLE_SSHD:=true}
141 141 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
142 142 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
143 143 ENABLE_SOUND=${ENABLE_SOUND:=true}
144 144 ENABLE_DBUS=${ENABLE_DBUS:=true}
145 145 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
146 146 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
147 147 ENABLE_XORG=${ENABLE_XORG:=false}
148 148 ENABLE_WM=${ENABLE_WM:=""}
149 149 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
150 150 ENABLE_USER=${ENABLE_USER:=true}
151 151 USER_NAME=${USER_NAME:="pi"}
152 152 ENABLE_ROOT=${ENABLE_ROOT:=false}
153 153 ENABLE_QEMU=${ENABLE_QEMU:=false}
154 154 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
155 155
156 156 # SSH settings
157 157 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
158 158 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
159 159 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
160 160 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
161 161 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
162 162
163 163 # Advanced settings
164 164 ENABLE_SYSTEMDSWAP=${ENABLE_SYSTEMDSWAP:=false}
165 165 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
166 166 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
167 167 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
168 168 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
169 169 ENABLE_USBBOOT=${ENABLE_USBBOOT=false}
170 170 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
171 171 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=false}
172 172 ENABLE_NEXMON=${ENABLE_NEXMON:=false}
173 173 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
174 174 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
175 175 NEXMONSRC_DIR=${NEXMONSRC_DIR:=""}
176 176 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
177 177 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
178 178 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
179 179 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
180 180 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
181 181 ENABLE_SPLASH=${ENABLE_SPLASH:=true}
182 182 ENABLE_LOGO=${ENABLE_LOGO:=true}
183 183 ENABLE_SILENT_BOOT=${ENABLE_SILENT_BOOT=false}
184 184 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
185 185
186 186 # Kernel compilation settings
187 187 BUILD_KERNEL=${BUILD_KERNEL:=true}
188 188 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
189 189 KERNEL_THREADS=${KERNEL_THREADS:=1}
190 190 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
191 191 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
192 192 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
193 193 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
194 194 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
195 195 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
196 196 KERNEL_VIRT=${KERNEL_VIRT:=false}
197 197 KERNEL_BPF=${KERNEL_BPF:=false}
198 198 KERNEL_DEFAULT_GOV=${KERNEL_DEFAULT_GOV:=ondemand}
199 199 KERNEL_SECURITY=${KERNEL_SECURITY:=false}
200 200 KERNEL_NF=${KERNEL_NF:=false}
201 201 KERNEL_DHKEY=${KERNEL_DHKEY:=true}
202 202 KERNEL_BTRFS=${KERNEL_BTRFS:=false}
203 203 KERNEL_NSPAN=${KERNEL_NSPAN:=false}
204 204 KERNEL_POEHAT=${KERNEL_POEHAT:=false}
205 205
206 206 # Kernel compilation from source directory settings
207 207 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
208 208 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
209 209 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
210 210 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
211 211
212 212 # Reduce disk usage settings
213 213 REDUCE_APT=${REDUCE_APT:=true}
214 214 REDUCE_DOC=${REDUCE_DOC:=true}
215 215 REDUCE_MAN=${REDUCE_MAN:=true}
216 216 REDUCE_VIM=${REDUCE_VIM:=false}
217 217 REDUCE_BASH=${REDUCE_BASH:=false}
218 218 REDUCE_HWDB=${REDUCE_HWDB:=true}
219 219 REDUCE_SSHD=${REDUCE_SSHD:=true}
220 220 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
221 221
222 222 # Encrypted filesystem settings
223 223 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
224 224 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
225 225 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
226 226 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64"}
227 227 CRYPTFS_HASH=${CRYPTFS_HASH:="sha512"}
228 228 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
229 229 #Dropbear-initramfs supports unlocking encrypted filesystem via SSH on bootup
230 230 CRYPTFS_DROPBEAR=${CRYPTFS_DROPBEAR:=false}
231 231 #Provide your own Dropbear Public RSA-OpenSSH Key otherwise it will be generated
232 232 CRYPTFS_DROPBEAR_PUBKEY=${CRYPTFS_DROPBEAR_PUBKEY:=""}
233 233
234 234 # Chroot scripts directory
235 235 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
236 236
237 237 # Packages required in the chroot build environment
238 238 APT_INCLUDES=${APT_INCLUDES:=""}
239 239 APT_INCLUDES="${APT_INCLUDES},flex,bison,libssl-dev,apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup,libnss-systemd"
240 240
241 241 # Packages to exclude from chroot build environment
242 242 APT_EXCLUDES=${APT_EXCLUDES:=""}
243 243
244 244 # Packages required for bootstrapping
245 245 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus bison flex libssl-dev sudo"
246 246 MISSING_PACKAGES=""
247 247
248 248 # Packages installed for c/c++ build environment in chroot (keep empty)
249 249 COMPILER_PACKAGES=""
250 250
251 251 # Check if apt-cacher-ng has port 3142 open and set APT_PROXY
252 252 APT_CACHER_RUNNING=$(lsof -i :3142 | cut -d ' ' -f3 | uniq | sed '/^\s*$/d')
253 253 if [ "${APT_CACHER_RUNNING}" = "apt-cacher-ng" ] ; then
254 254 APT_PROXY=http://127.0.0.1:3142/
255 255 fi
256 256
257 257 # Setup architecture specific settings
258 258 if [ -n "$SET_ARCH" ] ; then
259 259 # 64-bit configuration
260 260 if [ "$SET_ARCH" = 64 ] ; then
261 261 # General 64-bit depended settings
262 262 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
263 263 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
264 264 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
265 265
266 266 # Raspberry Pi model specific settings
267 267 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
268 268 if [ "$RPI_MODEL" != 4 ] ; then
269 269 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
270 270 else
271 271 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2711_defconfig}
272 272 fi
273 273
274 274 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
275 275 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
276 276 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
277 277 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
278 278 else
279 279 echo "error: Only Raspberry PI 3, 3B+ and 4 support 64-bit"
280 280 exit 1
281 281 fi
282 282 fi
283 283
284 284 # 32-bit configuration
285 285 if [ "$SET_ARCH" = 32 ] ; then
286 286 # General 32-bit dependend settings
287 287 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
288 288 KERNEL_ARCH=${KERNEL_ARCH:=arm}
289 289 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
290 290
291 291 # Raspberry Pi model specific settings
292 292 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
293 293 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
294 294 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
295 295 RELEASE_ARCH=${RELEASE_ARCH:=armel}
296 296 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
297 297 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
298 298 fi
299 299
300 300 # Raspberry Pi model specific settings
301 301 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
302 302 if [ "$RPI_MODEL" != 4 ] ; then
303 303 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
304 304 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
305 305 else
306 306 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2711_defconfig}
307 307 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7l.img}
308 308 fi
309 309
310 310 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
311 311 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
312 312
313 313 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
314 314 fi
315 315 fi
316 316 # SET_ARCH not set
317 317 else
318 318 echo "error: Please set '32' or '64' as value for SET_ARCH"
319 319 exit 1
320 320 fi
321 321 # Device specific configuration and U-Boot configuration
322 322 case "$RPI_MODEL" in
323 323 0)
324 324 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
325 325 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
326 326 ;;
327 327 1)
328 328 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
329 329 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
330 330 ;;
331 331 1P)
332 332 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
333 333 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
334 334 ;;
335 335 2)
336 336 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
337 337 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
338 338 ;;
339 339 3)
340 340 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
341 341 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
342 342 ;;
343 343 3P)
344 344 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
345 345 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
346 346 ;;
347 347 4)
348 348 DTB_FILE=${DTB_FILE:=bcm2711-rpi-4-b.dtb}
349 349 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_4_defconfig}
350 350 ;;
351 351 *)
352 352 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
353 353 exit 1
354 354 ;;
355 355 esac
356 356
357 357 # Raspberry PI 0,3,3P with Bluetooth and Wifi onboard
358 358 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
359 359 # Include bluetooth packages on supported boards
360 360 if [ "$ENABLE_BLUETOOTH" = true ] ; then
361 361 APT_INCLUDES="${APT_INCLUDES},bluetooth,bluez"
362 362 fi
363 363 if [ "$ENABLE_WIRELESS" = true ] ; then
364 364 APT_INCLUDES="${APT_INCLUDES},wireless-tools,crda,wireless-regdb"
365 365 fi
366 366 else # Raspberry PI 1,1P,2 without Wifi and bluetooth onboard
367 367 # Check if the internal wireless interface is not supported by the RPi model
368 368 if [ "$ENABLE_WIRELESS" = true ] || [ "$ENABLE_BLUETOOTH" = true ]; then
369 369 echo "error: The selected Raspberry Pi model has no integrated interface for wireless or bluetooth"
370 370 exit 1
371 371 fi
372 372 fi
373 373
374 374 if [ "$BUILD_KERNEL" = false ] && [ "$ENABLE_NEXMON" = true ]; then
375 375 echo "error: You have to compile kernel sources, if you want to enable nexmon"
376 376 exit 1
377 377 fi
378 378
379 379 # Prepare date string for default image file name
380 380 DATE="$(date +%Y-%m-%d)"
381 381 if [ -z "$KERNEL_BRANCH" ] ; then
382 382 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
383 383 else
384 384 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
385 385 fi
386 386
387 387 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
388 388 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
389 389 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
390 390 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
391 391 exit 1
392 392 fi
393 393 fi
394 394
395 395 # Add cmake to compile videocore sources
396 396 if [ "$ENABLE_VIDEOCORE" = true ] ; then
397 397 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
398 398 fi
399 399
400 400 # Add deps for nexmon
401 401 if [ "$ENABLE_NEXMON" = true ] ; then
402 402 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libgmp3-dev gawk qpdf make autoconf automake build-essential libtool"
403 403 fi
404 404
405 405 # Add libncurses5 to enable kernel menuconfig
406 406 if [ "$KERNEL_MENUCONFIG" = true ] ; then
407 407 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
408 408 fi
409 409
410 410 # Add ccache compiler cache for (faster) kernel cross (re)compilation
411 411 if [ "$KERNEL_CCACHE" = true ] ; then
412 412 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
413 413 fi
414 414
415 415 # Add cryptsetup package to enable filesystem encryption
416 416 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
417 417 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
418 418 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup,cryptsetup-initramfs"
419 419
420 420 # If cryptfs,dropbear and initramfs are enabled include dropbear-initramfs package
421 421 if [ "$CRYPTFS_DROPBEAR" = true ] && [ "$ENABLE_INITRAMFS" = true ]; then
422 422 APT_INCLUDES="${APT_INCLUDES},dropbear-initramfs"
423 423 fi
424 424
425 425 if [ -z "$CRYPTFS_PASSWORD" ] ; then
426 426 echo "error: no password defined (CRYPTFS_PASSWORD)!"
427 427 exit 1
428 428 fi
429 429 ENABLE_INITRAMFS=true
430 430 fi
431 431
432 432 # Add initramfs generation tools
433 433 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
434 434 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
435 435 fi
436 436
437 437 # Add device-tree-compiler required for building the U-Boot bootloader
438 438 if [ "$ENABLE_UBOOT" = true ] ; then
439 439 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex,bc"
440 440 fi
441 441
442 442 if [ "$ENABLE_USBBOOT" = true ] ; then
443 443 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 2 ]; then
444 444 echo "error: Booting from USB alone is only supported by Raspberry Pi 3 and 3P"
445 445 exit 1
446 446 fi
447 447 fi
448 448
449 449 # Check if root SSH (v2) public key file exists
450 450 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
451 451 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
452 452 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
453 453 exit 1
454 454 fi
455 455 fi
456 456
457 457 # Check if $USER_NAME SSH (v2) public key file exists
458 458 if [ -n "$SSH_USER_PUB_KEY" ] ; then
459 459 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
460 460 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
461 461 exit 1
462 462 fi
463 463 fi
464 464
465 465 if [ "$ENABLE_NEXMON" = true ] && [ -n "$KERNEL_BRANCH" ] ; then
466 466 echo "error: Please unset KERNEL_BRANCH if using ENABLE_NEXMON"
467 467 exit 1
468 468 fi
469 469
470 470 # Check if all required packages are installed on the build system
471 471 for package in $REQUIRED_PACKAGES ; do
472 472 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
473 473 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
474 474 fi
475 475 done
476 476
477 477 # If there are missing packages ask confirmation for install, or exit
478 478 if [ -n "$MISSING_PACKAGES" ] ; then
479 479 echo "the following packages needed by this script are not installed:"
480 480 echo "$MISSING_PACKAGES"
481 481
482 482 printf "\ndo you want to install the missing packages right now? [y/n] "
483 483 read -r confirm
484 484 [ "$confirm" != "y" ] && exit 1
485 485
486 486 # Make sure all missing required packages are installed
487 487 apt-get update && apt-get -qq -y install `echo "${MISSING_PACKAGES}" | sed "s/ //"`
488 488 fi
489 489
490 490 # Check if ./bootstrap.d directory exists
491 491 if [ ! -d "./bootstrap.d/" ] ; then
492 492 echo "error: './bootstrap.d' required directory not found!"
493 493 exit 1
494 494 fi
495 495
496 496 # Check if ./files directory exists
497 497 if [ ! -d "./files/" ] ; then
498 498 echo "error: './files' required directory not found!"
499 499 exit 1
500 500 fi
501 501
502 502 # Check if specified KERNELSRC_DIR directory exists
503 503 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
504 504 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
505 505 exit 1
506 506 fi
507 507
508 508 # Check if specified UBOOTSRC_DIR directory exists
509 509 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
510 510 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
511 511 exit 1
512 512 fi
513 513
514 514 # Check if specified VIDEOCORESRC_DIR directory exists
515 515 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
516 516 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
517 517 exit 1
518 518 fi
519 519
520 520 # Check if specified FBTURBOSRC_DIR directory exists
521 521 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
522 522 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
523 523 exit 1
524 524 fi
525 525
526 526 # Check if specified NEXMONSRC_DIR directory exists
527 527 if [ -n "$NEXMONSRC_DIR" ] && [ ! -d "$NEXMONSRC_DIR" ] ; then
528 528 echo "error: '${NEXMONSRC_DIR}' specified directory not found (NEXMONSRC_DIR)!"
529 529 exit 1
530 530 fi
531 531
532 532 # Check if specified CHROOT_SCRIPTS directory exists
533 533 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
534 534 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
535 535 exit 1
536 536 fi
537 537
538 538 # Check if specified device mapping already exists (will be used by cryptsetup)
539 539 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
540 540 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
541 541 exit 1
542 542 fi
543 543
544 544 # Don't clobber an old build
545 545 if [ -e "$BUILDDIR" ] ; then
546 546 echo "error: directory ${BUILDDIR} already exists, not proceeding"
547 547 exit 1
548 548 fi
549 549
550 550 # Setup chroot directory
551 551 mkdir -p "${R}"
552 552
553 553 # Check if build directory has enough of free disk space >512MB
554 554 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
555 555 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
556 556 exit 1
557 557 fi
558 558
559 559 set -x
560 560
561 561 # Call "cleanup" function on various signals and errors
562 562 trap cleanup 0 1 2 3 6
563 563
564 564 # Add required packages for the minbase installation
565 565 if [ "$ENABLE_MINBASE" = true ] ; then
566 566 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
567 567 fi
568 568
569 569 # Add parted package, required to get partprobe utility
570 570 if [ "$EXPANDROOT" = true ] ; then
571 571 APT_INCLUDES="${APT_INCLUDES},parted"
572 572 fi
573 573
574 574 # Add dphys-swapfile package, required to enable swap
575 575 if [ "$ENABLE_DPHYSSWAP" = true ] ; then
576 576 APT_INCLUDES="${APT_INCLUDES},dphys-swapfile"
577 577 fi
578 578
579 579 # Add dbus package, recommended if using systemd
580 580 if [ "$ENABLE_DBUS" = true ] ; then
581 581 APT_INCLUDES="${APT_INCLUDES},dbus"
582 582 fi
583 583
584 584 # Add iptables IPv4/IPv6 package
585 585 if [ "$ENABLE_IPTABLES" = true ] ; then
586 586 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
587 587 fi
588 588 # Add apparmor for KERNEL_SECURITY
589 589 if [ "$KERNEL_SECURITY" = true ] ; then
590 590 APT_INCLUDES="${APT_INCLUDES},apparmor,apparmor-utils,apparmor-profiles,apparmor-profiles-extra,libapparmor-perl"
591 591 fi
592 592
593 593 # Add openssh server package
594 594 if [ "$ENABLE_SSHD" = true ] ; then
595 595 APT_INCLUDES="${APT_INCLUDES},openssh-server"
596 596 fi
597 597
598 598 # Add alsa-utils package
599 599 if [ "$ENABLE_SOUND" = true ] ; then
600 600 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
601 601 fi
602 602
603 603 # Add rng-tools package
604 604 if [ "$ENABLE_HWRANDOM" = true ] ; then
605 605 APT_INCLUDES="${APT_INCLUDES},rng-tools"
606 606 fi
607 607
608 608 # Add fbturbo video driver
609 609 if [ "$ENABLE_FBTURBO" = true ] ; then
610 610 # Enable xorg package dependencies
611 611 ENABLE_XORG=true
612 612 fi
613 613
614 614 # Add user defined window manager package
615 615 if [ -n "$ENABLE_WM" ] ; then
616 616 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
617 617
618 618 # Enable xorg package dependencies
619 619 ENABLE_XORG=true
620 620 fi
621 621
622 622 # Add xorg package
623 623 if [ "$ENABLE_XORG" = true ] ; then
624 624 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
625 625 fi
626 626
627 627 # Replace selected packages with smaller clones
628 628 if [ "$ENABLE_REDUCE" = true ] ; then
629 629 # Add levee package instead of vim-tiny
630 630 if [ "$REDUCE_VIM" = true ] ; then
631 631 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
632 632 fi
633 633
634 634 # Add dropbear package instead of openssh-server
635 635 if [ "$REDUCE_SSHD" = true ] ; then
636 636 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
637 637 fi
638 638 fi
639 639
640 640 # Configure systemd-sysv exclude to make halt/reboot/shutdown scripts available
641 641 if [ "$ENABLE_SYSVINIT" = false ] ; then
642 642 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
643 643 fi
644 644
645 645 # Configure kernel sources if no KERNELSRC_DIR
646 646 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
647 647 KERNELSRC_CONFIG=true
648 648 fi
649 649
650 650 # Configure reduced kernel
651 651 if [ "$KERNEL_REDUCE" = true ] ; then
652 652 KERNELSRC_CONFIG=false
653 653 fi
654 654
655 655 # Configure qemu compatible kernel
656 656 if [ "$ENABLE_QEMU" = true ] ; then
657 657 DTB_FILE=vexpress-v2p-ca15_a7.dtb
658 658 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
659 659 KERNEL_DEFCONFIG="vexpress_defconfig"
660 660 if [ "$KERNEL_MENUCONFIG" = false ] ; then
661 661 KERNEL_OLDDEFCONFIG=true
662 662 fi
663 663 fi
664 664
665 665 # Execute bootstrap scripts
666 666 for SCRIPT in bootstrap.d/*.sh; do
667 667 head -n 3 "$SCRIPT"
668 668 . "$SCRIPT"
669 669 done
670 670
671 671 ## Execute custom bootstrap scripts
672 672 if [ -d "custom.d" ] ; then
673 673 for SCRIPT in custom.d/*.sh; do
674 674 . "$SCRIPT"
675 675 done
676 676 fi
677 677
678 678 # Execute custom scripts inside the chroot
679 679 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
680 680 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
681 681 chroot_exec /bin/bash -x <<'EOF'
682 682 for SCRIPT in /chroot_scripts/* ; do
683 683 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
684 684 $SCRIPT
685 685 fi
686 686 done
687 687 EOF
688 688 rm -rf "${R}/chroot_scripts"
689 689 fi
690 690
691 691 # Remove c/c++ build environment from the chroot
692 692 chroot_remove_cc
693 693
694 694 # Generate required machine-id
695 695 MACHINE_ID=$(dbus-uuidgen)
696 696 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
697 697 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
698 698
699 699 # APT Cleanup
700 700 chroot_exec apt-get -y clean
701 701 chroot_exec apt-get -y autoclean
702 702 chroot_exec apt-get -y autoremove
703 703
704 704 # Unmount mounted filesystems
705 705 umount -l "${R}/proc"
706 706 umount -l "${R}/sys"
707 707
708 708 # Clean up directories
709 709 rm -rf "${R}/run/*"
710 710 rm -rf "${R}/tmp/*"
711 711
712 712 # Clean up APT proxy settings
713 713 if [ "$KEEP_APT_PROXY" = false ] ; then
714 714 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
715 715 fi
716 716
717 717 # Clean up files
718 718 rm -f "${ETC_DIR}/ssh/ssh_host_*"
719 719 rm -f "${ETC_DIR}/dropbear/dropbear_*"
720 720 rm -f "${ETC_DIR}/apt/sources.list.save"
721 721 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
722 722 rm -f "${ETC_DIR}/*-"
723 723 rm -f "${ETC_DIR}/resolv.conf"
724 724 rm -f "${R}/root/.bash_history"
725 725 rm -f "${R}/var/lib/urandom/random-seed"
726 726 rm -f "${R}/initrd.img"
727 727 rm -f "${R}/vmlinuz"
728 728 rm -f "${R}${QEMU_BINARY}"
729 729
730 730 if [ "$ENABLE_QEMU" = true ] ; then
731 731 # Setup QEMU directory
732 732 mkdir "${BASEDIR}/qemu"
733 733
734 734 # Copy kernel image to QEMU directory
735 735 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
736 736
737 737 # Copy kernel config to QEMU directory
738 738 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
739 739
740 740 # Copy kernel dtbs to QEMU directory
741 741 for dtb in "${BOOT_DIR}/"*.dtb ; do
742 742 if [ -f "${dtb}" ] ; then
743 743 install_readonly "${dtb}" "${BASEDIR}/qemu/"
744 744 fi
745 745 done
746 746
747 747 # Copy kernel overlays to QEMU directory
748 748 if [ -d "${BOOT_DIR}/overlays" ] ; then
749 749 # Setup overlays dtbs directory
750 750 mkdir "${BASEDIR}/qemu/overlays"
751 751
752 752 for dtb in "${BOOT_DIR}/overlays/"*.dtbo ; do
753 753 if [ -f "${dtb}" ] ; then
754 754 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
755 755 fi
756 756 done
757 757 fi
758 758
759 759 # Copy u-boot files to QEMU directory
760 760 if [ "$ENABLE_UBOOT" = true ] ; then
761 761 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
762 762 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
763 763 fi
764 764 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
765 765 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
766 766 fi
767 767 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
768 768 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
769 769 fi
770 770 fi
771 771
772 772 # Copy initramfs to QEMU directory
773 773 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
774 774 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
775 775 fi
776 776 fi
777 777
778 778 # Calculate size of the chroot directory in KB
779 779 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
780 780
781 781 # Calculate the amount of needed 512 Byte sectors
782 782 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
783 783 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
784 784 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
785 785
786 786 # The root partition is EXT4
787 787 # This means more space than the actual used space of the chroot is used.
788 788 # As overhead for journaling and reserved blocks 35% are added.
789 789 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
790 790
791 791 # Calculate required image size in 512 Byte sectors
792 792 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
793 793
794 794 # Prepare image file
795 795 if [ "$ENABLE_SPLITFS" = true ] ; then
796 796 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
797 797 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
798 798 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
799 799 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
800 800
801 801 # Write firmware/boot partition tables
802 802 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
803 803 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
804 804 EOM
805 805
806 806 # Write root partition table
807 807 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
808 808 ${TABLE_SECTORS},${ROOT_SECTORS},83
809 809 EOM
810 810
811 811 # Setup temporary loop devices
812 812 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
813 813 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
814 814 else # ENABLE_SPLITFS=false
815 815 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
816 816 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
817 817
818 818 # Write partition table
819 819 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
820 820 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
821 821 ${ROOT_OFFSET},${ROOT_SECTORS},83
822 822 EOM
823 823
824 824 # Setup temporary loop devices
825 825 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
826 826 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
827 827 fi
828 828
829 829 if [ "$ENABLE_CRYPTFS" = true ] ; then
830 830 # Create dummy ext4 fs
831 831 mkfs.ext4 "$ROOT_LOOP"
832 832
833 833 # Setup password keyfile
834 834 touch .password
835 835 chmod 600 .password
836 836 echo -n ${CRYPTFS_PASSWORD} > .password
837 837
838 838 # Initialize encrypted partition
839 839 cryptsetup --verbose --debug -q luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -h "${CRYPTFS_HASH}" -s "${CRYPTFS_XTSKEYSIZE}" .password
840 840
841 841 # Open encrypted partition and setup mapping
842 842 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
843 843
844 844 # Secure delete password keyfile
845 845 shred -zu .password
846 846
847 847 # Update temporary loop device
848 848 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
849 849
850 850 # Wipe encrypted partition (encryption cipher is used for randomness)
851 851 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
852 852 fi
853 853
854 854 # Build filesystems
855 855 mkfs.vfat "$FRMW_LOOP"
856 856 mkfs.ext4 "$ROOT_LOOP"
857 857
858 858 # Mount the temporary loop devices
859 859 mkdir -p "$BUILDDIR/mount"
860 860 mount "$ROOT_LOOP" "$BUILDDIR/mount"
861 861
862 862 mkdir -p "$BUILDDIR/mount/boot/firmware"
863 863 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
864 864
865 865 # Copy all files from the chroot to the loop device mount point directory
866 866 rsync -a "${R}/" "$BUILDDIR/mount/"
867 867
868 868 # Unmount all temporary loop devices and mount points
869 869 cleanup
870 870
871 871 # Create block map file(s) of image(s)
872 872 if [ "$ENABLE_SPLITFS" = true ] ; then
873 873 # Create block map files for "bmaptool"
874 874 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
875 875 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
876 876
877 877 # Image was successfully created
878 878 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
879 879 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
880 880 else
881 881 # Create block map file for "bmaptool"
882 882 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
883 883
884 884 # Image was successfully created
885 885 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
886 886
887 887 # Create qemu qcow2 image
888 888 if [ "$ENABLE_QEMU" = true ] ; then
889 889 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
890 890 QEMU_SIZE=16G
891 891
892 892 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
893 893 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
894 894
895 895 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
896 896 fi
897 897 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant